/**
This file is part of a project licensed under the GNU General Public License v3.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
*/

<script>
export default {
  props: {
    data: {
      type: Array,
      default: () => [],
    },
  },
  render(h) {
    return h("div", this.renderElement(this.data, h));
  },
  methods: {
    renderElement(elements = [], h) {
      return elements.map((element) => {
        const methodName = `render${this.toTitle(element.type)}`;
        const render = this[methodName];
        if (typeof render === "function") {
          return render.call(this, element, h);
        } else {
          console.warn(`method ${methodName} is not implemented`);
          return null;
        }
      });
    },
    renderHeading(element, h) {
      return h(
        `h${element.level}`,
        {
          class: `is-size-${element.level + 1}`,
        },
        this.renderElement(element.children, h)
      );
    },
    renderParagraph(element, h) {
      return h("p", this.renderElement(element.children, h));
    },
    renderList(element, h) {
      return h("ul", this.renderElement(element.children, h));
    },
    renderListItem(element, h) {
      return h("li", this.renderElement(element.children, h));
    },
    renderText(element, h) {
      return element.text;
    },
    renderEmphasis(element, h) {
      return h("em", this.renderElement(element.children, h));
    },
    renderStrong(element, h) {
      return h("strong", this.renderElement(element.children, h));
    },
    toTitle(string) {
      return (
        string[0].toUpperCase() +
        string
          .slice(1)
          .split("_")
          .map((t, i) => (i === 0 ? t[0] : t[0].toUpperCase()) + t.slice(1))
          .join("")
      );

      return string[0].toUpperCase() + string.slice(1);
    },
  },
};
</script>
